package service

import (
	"fmt"
	"iot_manager_service/app/record/dao"
	"iot_manager_service/app/record/edge_service"
	"iot_manager_service/util/common"
)

var LightRecordService = new(lightRecordService)

type lightRecordService struct{}

func (s *lightRecordService) List(searchValue, start, end string, id int, current int, size int) ([]dao.LightRecord, *common.Errors) {
	var record dao.LightRecord
	if searchValue != "" {
		record.LampPoleSn = searchValue
		record.LampPoleName = searchValue
	}
	offset := (current - 1) * size
	limit := size
	records, err := record.GetRecords(offset, limit, start, end)
	if err != nil {
		return nil, common.FailResponse(err.Error(), nil)
	}
	return records, nil
}

// Refresh 同步记录
func (s *lightRecordService) Refresh() {
	// TODO:边缘数据
	up := edge_service.RecordLightUp{}
	maxId, maxUpDateTime := dao.LightRecord{}.GetMaxIdAndUpDateTime()
	recordLightUpDatas, err := up.SyncRecord(maxId, maxUpDateTime)

	dao.LightRecord{}.BatchCreate(recordLightUpDatas)
	if err != nil {
		fmt.Printf("Refresh err.Error() = %v", err)
		return
	}
}
